<?php

namespace Phalcon\Mvc\Model;

abstract class Validator
{

    protected $_options;


    protected $_messages;


    /**
     * Phalcon\Mvc\Model\Validator constructor
     *
     * @param array $options 
     */
	public function __construct($options) {}

    /**
     * Appends a message to the validator
     *
     * @param string $message 
     * @param string $field 
     * @param string $type 
     */
	protected function appendMessage($message, $field = null, $type = null) {}

    /**
     * Returns messages generated by the validator
     *
     * @return array 
     */
	public function getMessages() {}

    /**
     * Returns all the options from the validator
     *
     * @return array 
     */
	protected function getOptions() {}

    /**
     * Returns an option
     *
     * @param	string option
     * @return	mixed
     * @param string $option 
     */
	protected function getOption($option) {}

    /**
     * Check whether a option has been defined in the validator options
     *
     * @param	string option
     * @return	boolean
     * @param string $option 
     * @return bool 
     */
	protected function isSetOption($option) {}

}
